$debug NOMOD51 OJ(RC_5DRV.OBJ)

NAME RC_5


%out(Type "1", if the transmitter part will be used, otherwise type "0", default 0)
%define(TxmitterStr)(%in)
%if (%len(%TxmitterStr) EQ 2) then (
  %set(Txmitter,0)
) else (
  %set(Txmitter,%TxmitterStr)
  %if ( (%Txmitter NE 0) AND (%Txmitter NE 1) )
  then (
    %out(*** WARNING #1000, define Txmitter bad(%Txmitter), set to default state.
    )
    %set(Txmitter,0)
  ) fi
) fi

%set(rx_REMOTE_INT_VECTOR,03H)
%out(Enter the interrupt vector address used by REMOTE in HEX )
%set(rx_REMOTE_INT_VECTOR,%in)

%out(Enter the name of RC_5 pins definition file (default RC_5.PIN) ? )
%define(RC_5_pins)(%in)
%if (%len(%RC_5_pins) EQ 2) then (
$INCLUDE(RC_5.PIN)
) else (
$INCLUDE(%substr(%RC_5_pins,1,%len(%RC_5_pins)-2))
) fi

USING 0

SYSTEM  	EQU 		0   			;Here is defined the system code of RC-5
										;which may be in range 0..7
										;(0 is prefered for TV's
PUBLIC InitRemote
%if (%txmitter NE 0) then (
PUBLIC TRANSMIT_REMOTE
PUBLIC tx_TXMITTER, TXMITTER, BYTE_TO_SEND_PRESENT
) fi
PUBLIC REMOTE_ENABLE, REMOTE_INT

EXTRN NUMBER(evRemoteDown)				;Remote button pressed
EXTRN NUMBER(evRemoteUp)				;Remote button released
EXTRN NUMBER(evRemoteRepeat)			;Remote button repeats while held down


EXTRN CODE(SetEvent)


%if (%txmitter NE 0) then (
TRANSMIT_REMOTE_PROC    SEGMENT CODE
PREPARE_TX_REMOTE_BIT   SEGMENT CODE
) fi
READ_REMOTE_PROC        SEGMENT CODE
INITREMOTE_CODE         SEGMENT CODE
INFRA_DATA              SEGMENT DATA
INFRA_BIT               SEGMENT BIT
COUNT                   EQU     R7


TimerCount60ms  EQU     (5*Fosc)        ;(1/12)*(Fosc*dt)
TimerCount6ms   EQU     (Fosc/2)

RSEG INFRA_DATA
REMOTE_REPEAT:          DS      1
rx_REMOTE_BIT_NO:       DS      1
rx_REMOTE_DATA:         DS      1
rx_WORK_REMOTE_DATA:    DS      2
rx_REMOTE_DLY:          DS      2
rx_SINGLE_CHNG_DLY_CNT: DS      2
rx_PREVIOUS_REMOTE_DATA:DS      1
%if (%txmitter NE 0) then (
tx_WORK_REMOTE_DATA DATA    rx_WORK_REMOTE_DATA
StoredTMOD:				DS		1
) fi

RSEG INFRA_BIT
rx_PREV_REMOTE_BIT:     DBIT    1
%if (%txmitter NE 0) then (
BYTE_TO_SEND_PRESENT:   DBIT    1
tx_TXMITTER:            DBIT    1
tx_TOGGLE:              DBIT    1
tx_BIT_BEING_TXMITTED:  DBIT    1   ;Other info of tx_TXMITTER content, but
                                    ;must exist, because tx_TXMITTER is used by
                                    ;Timer2 INT routine for gatting modulation
StoredTR0:				DBIT	1
) fi

;Remote control codes
NO_CHNG_DLY             EQU     1638            ;1.778ms interrupt value, 0666H
SINGLE_CHNG_DLY         EQU     2457            ;2.667ms interrupt value, 0999H
DOUBLE_CHNG_DLY         EQU     3277            ;3.556ms interrupt value, 0CCDH
;no_chng_dly            equ     (Fosc*1778)/12000 ;1.778ms interrupt value
;single_chng_dly        equ     (Fosc*2667)/12000 ;2.667ms interrupt value
;double_chng_dly        equ     (Fosc*3556)/12000 ;3.556ms interrupt value
$EJECT

%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
TMMOD   		EQU 		TMOD
TML 			EQU 		TL0
TMH 			EQU 		TH0
TMINT   		EQU 		TF0
ETM 			EQU 		ET0
TMR 			EQU 		TR0
TMCAPL  		EQU         TL0
TMCAPH  		EQU         TH0
) fi
%if (%rx_REMOTE_INT_VECTOR EQ 33H) then (
TMMOD   		EQU 		CMOD
TML 			EQU 		CL
TMH 			EQU         CH
TMINT   		EQU 		CCF0
TMR 			EQU 		CR
TMCAPL  		EQU         CCAP0L
TMCAPH  		EQU         CCAP0H
) fi
MODULATOR_LO	EQU 		TL2
MODULATOR_HI	EQU 		TH2
;************************** INTERRUPT VECTORING *******************************

CSEG AT %rx_REMOTE_INT_VECTOR
        JNB     REMOTE_INT,rx_CHECK_REMOTE_COMPLETE
        LJMP    READ_REMOTE
rx_CHECK_REMOTE_COMPLETE:
%if (%rx_REMOTE_INT_VECTOR EQ 33H) then (
        JNB     TMINT,rx_REMOTE_INT_END
        LJMP    CHECK_REMOTE_COMPLETE
) fi
rx_REMOTE_INT_END:
        RETI

%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
CSEG AT 0BH
TIMER0_INT:
        LJMP    CHECK_REMOTE_COMPLETE
) fi

cseg at 2bh
        LJMP    T2_INT

;*****************************************************************************/
;*********************** INTERRUPT PROCEDURES ********************************/
;*****************************************************************************/
;*********************************************************************
T2_INT_PROC SEGMENT CODE
RSEG T2_INT_PROC
T2_INT:
%if (%txmitter NE 0) then (
		JNB     BYTE_TO_SEND_PRESENT,T2_INT_END
		JNB     tx_TXMITTER,T2_INT_QUIT
		CPL     TXMITTER
T2_INT_QUIT:
		CLR     TF2
) fi
T2_INT_END:
		RETI
$EJECT
;******************************************************************************
;******************************************************************************
;******************************************************************************
RSEG READ_REMOTE_PROC
;******************************************************************************
READ_REMOTE:
;**************** First START bit of REMOTE command received ******************
;rx_REMOTE_BIT_NO was zeroed, REMOTE was silent. Read routine starts the TM0.
;run. For RC-5 code, the transmitt frequency is about 562.43Hz (half period
;0.889ms). The procesor increments timer every machine cycle, whose period
;duration 12/Fosc [us, MHz]. Timer 0 content is stored into rx_REMOTE_DLY by every
;interrupt, invoked by changing the RC-5 signal from "0" to "1". First received
;start bit changes in all casses from "0" to "1" and thus invokes interrupt,
;which initializes RC-5 command receiving by initializing some varibles, e.g.
;TM0, REMOTE_DLYT, rx_PREV_REMOTE_DLY to zero. Every next time interrupt will
;be activated after incrementing the timer 0. There are three possibilities:
;  1/ Interrupt activates after delay time equal to NO_CHNG_DLY
;  2/ Interrupt activates after delay time equal to SINGLE_CHNG_DLY
;  3/ Interrupt activates after delay time equal to DOUBLE_CHNG_DLY
;Case 1 simply repeats receiving the same bit as previously and increments
;then received bit counter by one.
;Case 2 increments rx_SINGLE_CHNG_DLY_CNT and if its value is an odd number,
;it receivs one bit other than previously received and then increments received
;bit counter by one. If the value is even, it increments rx_REMOTE_BIT_NO by
;two and receivs two bits, first the same as previous and second other than
;previous.
;Case 3 receivs two bits, first other than previous and second the same as
;previous. rx_REMOTE_BIT_NO is incremented by two.
;Finally, if 13-th bit is received, the falling edge of signal is checked
;to be lower time or higher time. Higher time means receiv of 14-th bit as
;a "0", which is to be received without interrupt.i
;All of the possibilities are documented in following figure, which examples
;receiving fictive code consisting of a start bit followed by seven data bits:
;(Letters N,S and D are shortcuts for three possibilities described above)
;
;
;  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ
;                                
;                 7ints/7bits
;     .  N  .  N  .  N  .  N  .  N  .  N  .  N  .
;     .     .     .     .     .     .     .     .
;  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  Ŀ  .
;    .                            .
;  .               6ints/7bits
;     .    S.    N.    N.    N.    N.    N.     .    
;     .     .     .     .     .     .     .     .    
;  Ŀ  Ŀ  .  Ŀ  Ŀ  Ŀ  .  Ŀ
;    .        .        .        .    
;  .                5ints/7bits
;     .    S.     .  S  .  N  .    S.     .  S  .    
;     .     .     .     .     .     .     .     .    
;  Ŀ  Ŀ  .  Ŀ  Ŀ  .  Ŀ  . 
;    .        .    .        .    .    .
;  .                 4ints/7bits
;     .    S.     .  S  .    S.     .  S  .     .    
;     .     .     .     .     .     .     .     .    
;  Ŀ  .  Ŀ  .  Ŀ  .  Ŀ  .
;    .    .    .    .    .    .    .    .
;  .    .             3ints/7bits
;     .     .  D  .     .  D  .     .  D  .     .    
;     .     .     .     .     .     .     .     .
;
;
;Symbols N, S and D are for no_change, single_change and double_change
;time delay, after which interrupt occurs. After all bits are received,
;rx_REMOTE_DATA are updated only if system bits are equal to current system.
;REMOTE_CMD_DONE flag remains clear until timer 0 overflows. This guarantes,
;that no more bits are received in case distortion or other remote source.
;Overflow causes interrupt, which checkes rx_REMOTE_BIT_NO variable for correct
;value. If less than 14 bits is received, receiv is aborted and re-initialized.
;If next bit is received durring waiting for timer 0 overflow, the same 
;aborting occurs.

        PUSH    ACC
        PUSH    PSW
        PUSH    AR0                     ;rx_REMOTE_BIT_NO zeroed means REMOTE
        PUSH    AR1                     ;was  silent, now first BIT is received
        MOV     A,rx_REMOTE_BIT_NO
        JNZ     rx_DATA_BIT             ;rx_REMOTE_BIT_NO zeroed means REMOTE
                    					;was silent, now, first BIT is received
rx_START_BIT:
%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
        ANL     TMMOD,#0F0H
        ORL     TMMOD,#1H                ;TM0 used as 16bit timer
) fi
%if (%rx_REMOTE_INT_VECTOR EQ 33H) then (
        MOV     TMMOD,#81H              ;CIDL=1 - Continue in IDLE mode
                                        ;ECF=1  - Interrupt on PCA tim. overfl.
                                        ;CPS0,1=0-1/12 Fosc 
) fi
        MOV     TML,#LOW(-TimerCount6ms);
        MOV     TMH,#HIGH(-TimerCount6ms);
        CLR     TMINT
%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
        SETB    ETM                     ;Initialize Timer INT, which occurs if
) fi                                    ;no more remote commands are received
        SETB    TMR                     ;Remeber, that if using the 80c51Fx, 
        MOV     R0,#rx_REMOTE_DLY       ;Timer Overflow INT is already enabled
        CLR     A                       ;by writting into CMOD
        MOV     R1,#4					;Don't clear rx_PREVIOUS_REMOTE_DATA
clr_rx_var:
        MOV     @R0,A
        INC     R0
        DJNZ    R1,CLR_rx_VAR

        CLR     A
        MOV     rx_WORK_REMOTE_DATA,A
        MOV     rx_WORK_REMOTE_DATA+1,A
        SETB    rx_PREV_REMOTE_BIT      ;Start bit is always "1"
        MOV     rx_REMOTE_BIT_NO,#1
;***********************************************
rx_REMOTE_END:
        CLR     REMOTE_INT
%if (%rx_REMOTE_INT_VECTOR EQ 33H) then (
        CLR     TMINT
) fi
        POP     AR1
        POP     AR0
        POP     PSW
        POP     ACC
        RETI
;***********************************************
rx_DATA_BIT:
%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
        CLR     TMR
) fi
        mov     r0,#rx_REMOTE_DLY
        MOV     @r0,TMCAPH
        inc     r0
        MOV     @r0,TMCAPL
%if (%rx_REMOTE_INT_VECTOR EQ 33H) then (
        CLR     TMR
) fi
        MOV     TML,#LOW(-TimerCount6ms);
        MOV     TMH,#HIGH(-TimerCount6ms);
        SETB    TMR
        CLR     C
        MOV     A,@r0
        SUBB    A,#LOW(-TimerCount6ms);
        MOV     @r0,A
        dec     r0
        MOV     A,@r0
        SUBB    A,#HIGH(-TimerCount6ms);
        MOV     @r0,a

        CJNE    A,#(HIGH(NO_CHNG_DLY+80H)-1),$+3
        JC      rx_REMOTE_ERR
        CJNE    A,#(1+HIGH(NO_CHNG_DLY+80H)),$+3
        JC      rx_REPEAT_PREV_BIT
        CJNE    A,#(1+HIGH(SINGLE_CHNG_DLY+80H)),$+3
        JC      CHANGE_PREV_BIT
        CJNE    A,#(1+HIGH(DOUBLE_CHNG_DLY+80H)),$+3
        JC      ADD_COMPLEMENT_OF_PREV_BIT
;***********************************************
rx_REMOTE_ERR:
%if (%rx_REMOTE_INT_VECTOR EQ 03H) then (
        CLR     ETM
) fi
        CLR     TMR
        CLR     TMINT
        CLR     REMOTE_INT
        CLR     A
        MOV     rx_REMOTE_BIT_NO,A      ;Clear REMOTE control variables
        MOV     REMOTE_REPEAT,A
        MOV     TML,A
        MOV     TMH,A
        MOV     rx_WORK_REMOTE_DATA,A
        MOV     rx_WORK_REMOTE_DATA+1,A
        MOV     rx_REMOTE_DATA,#0FFH    ;This code may never occur
        MOV     R0,#rx_REMOTE_DLY
        MOV     @R0,#0ffh
        PUSH	AR7
        PUSH	AR6
        MOV     R7,rx_PREVIOUS_REMOTE_DATA
        MOV     R6,#evRemoteUp
rx_UPDATE_EVENT:
        LCALL	SetEvent
        POP		AR6
        POP		AR7
        SJMP    rx_REMOTE_END
;***********************************************
rx_REPEAT_PREV_BIT:
        MOV     C,rx_PREV_REMOTE_BIT
        MOV     A,rx_WORK_REMOTE_DATA+1
        RLC     A
        MOV     rx_WORK_REMOTE_DATA+1,A
        MOV     A,rx_WORK_REMOTE_DATA
        RLC     A
        MOV     rx_WORK_REMOTE_DATA,A
        INC     rx_REMOTE_BIT_NO
        MOV     A,rx_REMOTE_BIT_NO
        CJNE    A,#14,CHECK_LAST_BIT_ZERO
        MOV     TML,#LOW(-TimerCount60ms);
        MOV     TMH,#HIGH(-TimerCount60ms);
        SJMP    _rx_REMOTE_END
;***********************************************
CHANGE_PREV_BIT:
        mov     r0,#rx_SINGLE_CHNG_DLY_CNT
        inc     @r0
        CPL     rx_PREV_REMOTE_BIT
        mov     a,@r0
        JNB     ACC.0,ADD_COMPLEMENT_OF_PREV_BIT ;Branch on even value
        JMP     rx_REPEAT_PREV_BIT
;***********************************************
ADD_COMPLEMENT_OF_PREV_BIT:
        MOV     C,rx_PREV_REMOTE_BIT
        CPL     C
        MOV     A,rx_WORK_REMOTE_DATA+1
        RLC     A
        MOV     rx_WORK_REMOTE_DATA+1,A
        MOV     A,rx_WORK_REMOTE_DATA
        RLC     A
        MOV     rx_WORK_REMOTE_DATA,A
        INC     rx_REMOTE_BIT_NO
        JMP     rx_REPEAT_PREV_BIT
;***********************************************
CHECK_LAST_BIT_ZERO:
        JNC     _rx_REMOTE_ERR          ;rx_REMOTE_BIT_NO grather than 14
        CJNE    A,#13,_rx_REMOTE_END
WAIT_FOR_LAST_BIT:
        JB      TMINT,BAD_LAST_ZERO_RC5 ;TMINT will not interrupt this loop
        JNB     RECEIVER,WAIT_FOR_LAST_BIT
        CLR     TMR
        mov     r0,#rx_REMOTE_DLY
        MOV     @r0,TMH
        inc     r0
        MOV     @r0,TML
        SETB    TMR
        CLR     C
        MOV     A,@r0
        SUBB    A,#LOW(-TimerCount6ms);
        MOV     @r0,A
        dec     r0
        MOV     A,@r0
        SUBB    A,#HIGH(-TimerCount6ms);
        MOV     @r0,a
        RL      A
        CJNE    A,#(1+HIGH(NO_CHNG_DLY+80H)),$+3
;Lower delay time than half of NO_CHNG_DLY means, that the last received bit
;will be other than previous bit.
        JNC     BIT_WILL_CHANGE
BIT_WILL_NOT_CHANGE:
        JB      rx_PREV_REMOTE_BIT,_rx_REMOTE_END
BAD_LAST_ZERO_RC5:
        CLR     rx_PREV_REMOTE_BIT
        JMP     rx_REPEAT_PREV_BIT
BIT_WILL_CHANGE:
        JNB     rx_PREV_REMOTE_BIT,_rx_REMOTE_END
        CLR     rx_PREV_REMOTE_BIT
        JMP     rx_REPEAT_PREV_BIT
_rx_REMOTE_END:
        JMP     rx_REMOTE_END
;******************************************************************************
CHECK_REMOTE_COMPLETE:                  ;Invoked on Timer overflow
        PUSH    ACC
        PUSH    PSW
        PUSH    AR0                     ;rx_REMOTE_BIT_NO zeroed means REMOTE
        PUSH    AR1                     ;was  silent, now first BIT is received
        MOV     A,rx_REMOTE_BIT_NO
        XRL     A,#14
        JZ      REMOTE_DATA_COMPLETE
_rx_REMOTE_ERR:
        JMP     rx_REMOTE_ERR
REMOTE_DATA_COMPLETE:
        CLR     A
        MOV     rx_REMOTE_BIT_NO,A

        MOV     A,rx_WORK_REMOTE_DATA
        ANL     A,#00110111B            ;Mask off toggle bit
        CJNE    A,#(00010000B or SYSTEM shr 2),_rx_REMOTE_ERR
        MOV     A,rx_WORK_REMOTE_DATA+1
        ANL     A,#11000000B            ;Mask off toggle bit
        CJNE    A,#((SYSTEM and 3) shl 6),_rx_REMOTE_ERR

        MOV     A,rx_WORK_REMOTE_DATA+1
        ANL     A,#00111111B

        CJNE    A,rx_REMOTE_DATA,NEW_REMOTE_DATA
        MOV     A,REMOTE_REPEAT
        INC     REMOTE_REPEAT
        CJNE    A,#10,_rx_REMOTE_END
        MOV     REMOTE_REPEAT,#8
        PUSH	AR7
        PUSH	AR6
        MOV     R7,rx_REMOTE_DATA
        MOV     R6,#evRemoteRepeat
        JMP		rx_UPDATE_EVENT

NEW_REMOTE_DATA:
        MOV     rx_REMOTE_DATA,A
        MOV     rx_PREVIOUS_REMOTE_DATA,A
        MOV     REMOTE_REPEAT,#1
        PUSH	AR7
        PUSH	AR6
        MOV     R7,A
        MOV     R6,#evRemoteDown
        JMP		rx_UPDATE_EVENT
;******************************************************************************
;******************************************************************************
;******************************************************************************
$EJECT
;******************************************************************************
;******************************************************************************
;******************************** PROCEDURES **********************************
;******************************************************************************
;******************************************************************************
%if (%txmitter NE 0) then (
RSEG PREPARE_TX_REMOTE_BIT
tx_GET_NEXT_BIT_TO_SEND:
        CLR     C
        MOV     A,tx_WORK_REMOTE_DATA+1
        RLC     A
        MOV     tx_WORK_REMOTE_DATA+1,A
        MOV     A,tx_WORK_REMOTE_DATA
        RLC     A
        MOV     tx_WORK_REMOTE_DATA,A
        MOV     tx_BIT_BEING_TXMITTED,C
        RET
$EJECT
;******************************************************************************
;******************************************************************************
;******************************************************************************
RSEG TRANSMIT_REMOTE_PROC
TRANSMIT_REMOTE:
;Fourteen bytes have to be send, starting at START bit (1), then a command
;page bit (0 for command codes 64..128, 1 for command codes 0..63)(0), then 
;toggle bit (0), then five system bit and finally six data bits.
;Then Byte to be transmitted is passed in R7, System code in R5.

        CLR     ET0
        CLR     TR0
        MOV		StoredTMOD,TMOD
        MOV		C,TR0
        MOV		StoredTR0,C
        ANL     TMOD,#0F0H
        ORL     TMOD,#1H                ;TM0 used as 16bit timer
        mov     a,r7                    ;Get Command byte
        mov     c,acc.6                 ;Create command page bit
        cpl     c
        mov     a,r5                    ;SYSTEM_CODE
        anl     a,#00011111b
        orl     a,#80h                  ;Set START bit to (1)
        mov     acc.6,c                 ;Update page bit
        MOV     C,tx_TOGGLE
        mov     acc.5,c                 ;Update toggle bit
        CPL     tx_TOGGLE
        MOV     tx_WORK_REMOTE_DATA,A

        mov     a,r7                    ;Get Command byte
        anl     a,#00111111b
        rl      a
        rl      a
        MOV     tx_WORK_REMOTE_DATA+1,A

        MOV     COUNT,#14               ;Txmit 14 bits

        CALL    tx_GET_NEXT_BIT_TO_SEND ;Start bit first
        SETB    BYTE_TO_SEND_PRESENT    ;Indicate start of txmit
        CLR     ET2
        MOV     MODULATOR_LO,#(LOW(-14))
        MOV     MODULATOR_HI,#(HIGH(-14))
        MOV     T2CON,#0
        SETB    TR2
        CLR     TF2
        SETB    ET2

tx_OUT_BIT:
        CLR     EA
        MOV     C,tx_BIT_BEING_TXMITTED
        CPL     C                       ;Bit beguns with inverted part
        MOV     tx_TXMITTER,C           ;(a "1" is sent as "0" to "1"
        MOV     TXMITTER,C              ;transition)
        SETB    EA
        CLR     TR0
        CLR     TF0
        MOV     TL0,#LOW(-((NO_CHNG_DLY/2)-75))
        MOV     TH0,#HIGH(-((NO_CHNG_DLY/2)-75))
        SETB    TR0
        JNB     TF0,$
        CLR     EA
        CPL     tx_TXMITTER
        MOV     C,tx_TXMITTER
        MOV     TXMITTER,C
        SETB    EA
        CLR     TR0
        CLR     TF0
        MOV     TL0,#LOW(-((NO_CHNG_DLY/2)-75))
        MOV     TH0,#HIGH(-((NO_CHNG_DLY/2)-75))
        SETB    TR0

tx_PREPARE_NEXT_BIT:
        CALL    tx_GET_NEXT_BIT_TO_SEND
        JNB     TF0,$
        DJNZ    COUNT,tx_OUT_BIT

        JB      tx_BIT_BEING_TXMITTED,tx_TRANSMIT_REMOTE_END
        CLR     TF0
        CLR     tx_TXMITTER
        CLR     TXMITTER
        CLR     TR0
        MOV     TL0,#LOW(-((NO_CHNG_DLY/2)-75))
        MOV     TH0,#HIGH(-((NO_CHNG_DLY/2)-75))
        SETB    TR0
        JNB     TF0,$

tx_TRANSMIT_REMOTE_END:
        CLR     TF0
        CLR     TR0
        CLR     ET2
        CLR     TF2
        SETB    EA
        CLR     tx_TXMITTER
        CLR     TXMITTER
        RET
$EJECT
) fi
;******************************************************************************
;******************************************************************************
;******************************************************************************
RSEG INITREMOTE_CODE
INITREMOTE:
        CLR     A
        MOV     rx_REMOTE_BIT_NO,A      ;Clear REMOTE control variables
        MOV     REMOTE_REPEAT,A
        MOV     rx_REMOTE_DATA,#0FFH    ;This code may never occur
%if (%txmitter NE 0) then (
        CLR     TXMITTER
        CLR     tx_TXMITTER
) fi
%if (%RX_REMOTE_INT_VECTOR EQ 03H) then (
        SETB    EX0
        SETB    IT0                     ;Falling edge sensitive
        SETB    PX0                     ;Highest priority for REMOTE_INT
) fi
%if (%RX_REMOTE_INT_VECTOR EQ 4BH) then (
        CLR     I2FR                    ;Negative transition activated
        ANL     IP0,#NOT(2)
        ANL     IP1,#NOT(2)             ;Lowest priority for INT2
        ORL     IP0,#00100000B
        ORL     IP1,#00100000B          ;Highest priority for T2INT
) fi
%if (%RX_REMOTE_INT_VECTOR EQ 33H) then (
        MOV     CMOD,#81H               ;CIDL=1 - Continue in IDLE mode
                                        ;ECF=1  - Interrupt on PCA tim. overfl.
        MOV     CCAPM0,#00010001B       ;CAPN0=1 - Capture on neg. transition
                                        ;ECCF0=1 - Enable CAP0 INT
        SETB    PPC                     ;CAP0 INT, will have high priority
) fi
        CLR     REMOTE_INT              ;Clear possible INT2 flag
        SETB    REMOTE_ENABLE
        RET

END
